unit eBob42.Temperature;
interface
uses
  System.Drawing, System.Collections, System.ComponentModel;

type
  TemperatureAssignmentEventArgs = class(EventArgs)
  public
    FKelvin: Double;
  public
    property Kelvin: Double read FKelvin write FKelvin;
  end;

  TemperatureAssignmentHandler = procedure (Sender: TObject; e: TemperatureAssignmentEventArgs) of object;


  TemperatureConversion = class(System.ComponentModel.Component)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    FKelvin: Double;
    { Private Declarations }
  private
    const Kelvin2Celsius = 273.15;
  public
    constructor Create; overload;
    constructor Create(Container: System.ComponentModel.IContainer); overload;
    procedure set_Kelvin(const Value: Double);
    function get_Celsius: Double;
    procedure set_Celsius(const Value: Double);
  published
    property Kelvin: Double read FKelvin write set_Kelvin;
    property Celsius: Double read get_Celsius write set_Celsius;
  protected
    procedure OnTemperatureAssignment(args: TemperatureAssignmentEventArgs); virtual;
  private
    FTemperatureAssignment: TemperatureAssignmentHandler;
  published
    property TemperatureAssignment: TemperatureAssignmentHandler
      add FTemperatureAssignment remove FTemperatureAssignment;
  end;

implementation
uses
  System.Globalization;

{$AUTOBOX ON}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support - do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TemperatureConversion.InitializeComponent;
begin
end;
{$ENDREGION}

constructor TemperatureConversion.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

constructor TemperatureConversion.Create(Container: System.ComponentModel.IContainer);
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  Container.Add(Self);
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

procedure TemperatureConversion.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

procedure TemperatureConversion.set_Kelvin(const Value: Double);
var
  Args: TemperatureAssignmentEventArgs;
begin
  if Value < 0 then
  begin
    Args := TemperatureAssignmentEventArgs.Create;
    Args.Kelvin := Value;
    OnTemperatureAssignment(Args);
    FKelvin := Args.Kelvin;
  end
  else
    FKelvin := Value;
end;

function TemperatureConversion.get_Celsius: Double;
begin
  Result := Kelvin - Kelvin2Celsius;
end;

procedure TemperatureConversion.set_Celsius(const Value: Double);
begin
  Kelvin := Value + Kelvin2Celsius
end;

procedure TemperatureConversion.OnTemperatureAssignment(
  args: TemperatureAssignmentEventArgs);
begin
  if Assigned(FTemperatureAssignment) then
    FTemperatureAssignment(Self, args);
end;

end.
