unit Oblong.Design.DateProperty;

interface

uses
  Borland.Vcl.Design.DesignIntf, Borland.Vcl.Design.DesignEditors;

type
  TDateProperty = class(Borland.Vcl.Design.DesignEditors.TDateProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

implementation

uses
  Forms, ComCtrls, Classes, Controls, StdCtrls;

{ TDateProperty }

procedure TDateProperty.Edit;
var
  Form: TForm;
  Calendar: TMonthCalendar;
begin
  Form := TForm.Create(nil);
  with Form do
  try
    BorderStyle := bsToolWindow;
    Caption := (GetComponent(0) as TComponent).Name + '.' + GetName;
    ClientWidth := 169;
    Position := poMainFormCenter;
    Calendar := TMonthCalendar.Create(Form);
    with Calendar do
    begin
      Parent := Form;
      Align := alTop;
      Date := GetFloatValue
    end;
    with TButton.Create(Form) do
    begin
      Parent := Form;
      Caption := 'OK';
      ModalResult := mrOk;
      Default := True;
      Left := 8;
      Top := 8 + Calendar.Height
    end;
    with TButton.Create(Form) do
    begin
      Parent := Form;
      Caption := 'Cancel';
      ModalResult := mrCancel;
      Cancel := True;
      Left := 90;
      Top := 8 + Calendar.Height
    end;
    ClientHeight := 40 + Calendar.Height;
    if ShowModal = mrOk then
      SetFloatValue(Calendar.Date)
  finally
    Free
  end
end;

function TDateProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paDialog, paMultiSelect]
end;

end.
