unit eBob42.Euro;
{$S+}
interface
uses
  Classes;

type
  TEuro = class(TComponent)
  private
    { Private declarations }
    FEuro: Currency;
    function GetIEP: Currency;
    function GetFIM: Currency;
    function GetNLG: Currency;
    function GetBEF: Currency;
    function GetLUF: Currency;
    function GetDEM: Currency;
    function GetATS: Currency;
    function GetFRF: Currency;
    function GetITL: Currency;
    function GetESP: Currency;
    function GetPTE: Currency;
    function GetGRO: Currency;
    procedure SetEuro(const Value: Currency);
    procedure SetIEP(const Value: Currency);
    procedure SetFIM(const Value: Currency);
    procedure SetNLG(const Value: Currency);
    procedure SetBEF(const Value: Currency);
    procedure SetLUF(const Value: Currency);
    procedure SetDEM(const Value: Currency);
    procedure SetATS(const Value: Currency);
    procedure SetFRF(const Value: Currency);
    procedure SetITL(const Value: Currency);
    procedure SetESP(const Value: Currency);
    procedure SetPTE(const Value: Currency);
    procedure SetGRO(const Value: Currency);
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
    property Euro: Currency read FEuro write SetEuro;
    property IEP: Currency read GetIEP write SetIEP;
    property FIM: Currency read GetFIM write SetFIM;
    property NLG: Currency read GetNLG write SetNLG;
    property BEF: Currency read GetBEF write SetBEF;
    property LUF: Currency read GetLUF write SetLUF;
    property DEM: Currency read GetDEM write SetDEM;
    property ATS: Currency read GetATS write SetATS;
    property ITL: Currency read GetITL write SetITL;
    property FRF: Currency read GetFRF write SetFRF;
    property ESP: Currency read GetESP write SetESP;
    property PTE: Currency read GetPTE write SetPTE;
    property GRO: Currency read GetGRO write SetGRO;
  end;

implementation

// Conversion Rate constants

type
  TConversionRate = class
    const IEP = 0.787564;
    const FIM = 5.94573;
    const NLG = 2.20371;
    const BEF = 40.3399;
    const LUF = 40.3399;
    const DEM = 1.95583;
    const ATS = 13.7603;
    const FRF = 6.55957;
    const ITL = 1936.27;
    const ESP = 166.386;
    const PTE = 200.482;
    const GRO = 340.750;
  end;

{ TEuro }

// Euro Setter

procedure TEuro.SetEuro(const Value: Currency);
begin
  FEuro := Value;
end;

// Getters

function TEuro.GetIEP: Currency;
begin
  Result := FEuro * TConversionRate.IEP
end;

function TEuro.GetFIM: Currency;
begin
  Result := FEuro * TConversionRate.FIM
end;

function TEuro.GetNLG: Currency;
begin
  Result := FEuro * TConversionRate.NLG
end;

function TEuro.GetBEF: Currency;
begin
  Result := FEuro * TConversionRate.BEF
end;

function TEuro.GetLUF: Currency;
begin
  Result := FEuro * TConversionRate.LUF
end;

function TEuro.GetDEM: Currency;
begin
  Result := FEuro * TConversionRate.DEM
end;

function TEuro.GetATS: Currency;
begin
  Result := FEuro * TConversionRate.ATS
end;

function TEuro.GetFRF: Currency;
begin
  Result := FEuro * TConversionRate.FRF
end;

function TEuro.GetITL: Currency;
begin
  Result := FEuro * TConversionRate.ITL
end;

function TEuro.GetESP: Currency;
begin
  Result := FEuro * TConversionRate.ESP
end;

function TEuro.GetPTE: Currency;
begin
  Result := FEuro * TConversionRate.PTE
end;

function TEuro.GetGRO: Currency;
begin
  Result := FEuro * TConversionRate.GRO
end;

// Setters

procedure TEuro.SetIEP(const Value: Currency);
begin
  FEuro := Value / TConversionRate.IEP
end;

procedure TEuro.SetFIM(const Value: Currency);
begin
  FEuro := Value / TConversionRate.FIM
end;

procedure TEuro.SetNLG(const Value: Currency);
begin
  FEuro := Value / TConversionRate.NLG
end;

procedure TEuro.SetBEF(const Value: Currency);
begin
  FEuro := Value / TConversionRate.BEF
end;

procedure TEuro.SetLUF(const Value: Currency);
begin
  FEuro := Value / TConversionRate.LUF
end;

procedure TEuro.SetDEM(const Value: Currency);
begin
  FEuro := Value / TConversionRate.DEM
end;

procedure TEuro.SetATS(const Value: Currency);
begin
  FEuro := Value / TConversionRate.ATS
end;

procedure TEuro.SetFRF(const Value: Currency);
begin
  FEuro := Value / TConversionRate.FRF
end;

procedure TEuro.SetITL(const Value: Currency);
begin
  FEuro := Value / TConversionRate.ITL
end;

procedure TEuro.SetESP(const Value: Currency);
begin
  FEuro := Value / TConversionRate.ESP
end;

procedure TEuro.SetPTE(const Value: Currency);
begin
  FEuro := Value / TConversionRate.PTE
end;

procedure TEuro.SetGRO(const Value: Currency);
begin
  FEuro := Value / TConversionRate.GRO
end;

end.
