unit eBob42.ComponentEditors;
interface
uses
  DesignIntf, DesignEditors;

type
  TDataSourceComponentEditor = class(TDefaultEditor)
  public
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): string; override;
    procedure ExecuteVerb(Index: Integer); override;
    procedure Edit; override;
  end;

implementation
uses
  Classes, DB, Dialogs;

{ TDataSourceComponentEditor }

function TDataSourceComponentEditor.GetVerbCount: Integer;
var
  Child: TComponent;
begin
  Result := 1; // for the About box...
  if Assigned(Component.Owner) then
    for Child in Component.Owner do
      if Child is TDataSet then Inc(Result);
end;

function TDataSourceComponentEditor.GetVerb(Index: Integer): string;
var
  Child: TComponent;
begin
  if index = 0 then Result := '&About TDataSourceComponentEditor...'
  else
    if Assigned(Component.Owner) then
      for Child in Component.Owner do
        if Child is TDataSet then
        begin
          Dec(Index);
          if Index = 0 then Result := 'Connect to ' + Child.Name
        end
end;

procedure TDataSourceComponentEditor.ExecuteVerb(Index: Integer);
var
  Child: TComponent;
begin
  if (index = 0) then Edit
  else
    if Assigned(Component.Owner) then
      for Child in Component.Owner do
        if Child is TDataSet then
        begin
          Dec(Index);
          if Index = 0 then
          begin
            (Component as TDataSource).DataSet := Child as TDataSet;
            Designer.Modified;
          end
        end
end;

procedure TDataSourceComponentEditor.Edit;
begin
  ShowMessage(GetVerb(0));
  inherited
end;

end.
